
//#include "Python.h"
#include <stdlib.h>
#include <time.h>
#include "Array2.h"
#define MAX 32768

Array2::Array2 () {

}
int chooseRandom (int max) {
        int val=0;
        float tmp1;
	int hasard = -0;
        //srand (time(0));

        val = rand();
        //tmp1 = float((val-(INT_MAX/2)))/float((INT_MAX/2));

        //val = rand48();
        tmp1 = float(val-(MAX/2))/float(MAX/2);

	hasard = (int) (tmp1*max);
	//printf("val = %d, %f, %f, tmp1 = %f, hasard =%d\n",val, float(val-(MAX/2)),float(MAX/2), tmp1, hasard);
	return( hasard);
}
void Array2::Init(int taille) {
	coeff = taille;
	
    largeur=(1<<taille);
	//printf ("largeur= %d\n",largeur);
	tableau = (Point *)malloc((1+largeur)*(largeur+1)*sizeof (Point));
	//tableau = new Point[largeur*largeur+largeur];
	for (int ii=0; ii<=largeur; ii++){
		for (int jj=0; jj<=largeur; jj++) {
			(tableau[ii*(largeur+1)+jj]).x=ii;
			tableau[ii*(largeur+1)+jj].y=jj;
			//printf(" tab [%d,%d] = (%d,%d)\n",ii,jj,ii,jj);
			tableau[ii*(largeur+1)+jj].z=0;
		}
	}
	for (int ii=0; ii<=largeur ; ii++)
	{
		tableau[ii*(largeur+1)+0].z=1;
		tableau[ii*(largeur+1)+(largeur)].z=1;
		tableau[0+ii].z=1;
		tableau[(largeur)*(largeur+1)+ii].z=1;
	}
	//tableau [0*(largeur+1)+0].z=0.0;
	//tableau [(largeur-1)*(largeur+1)+0].z=0.0;
	//tableau [0*largeur+largeur-1].z=0.0;
	//tableau [largeur-1*largeur+largeur-1].z=0.0;
	//srand (time(0));
}

void Array2::setElement(int i,int j, int valeur) {
	(tableau[i*(largeur+1)+j]).z = valeur;
}

int Array2::getElement(int i, int j) {
	return(tableau[i*(largeur+1)+j].z);
}

Array2::~Array2 () {
}
void Array2::dispose() {
	delete [] tableau;
	//tableau = NULL;
}
Point *Array2::getData () {
	return (tableau);
}

void Array2::Square(Point p1, Point p2,Point  p3,Point   p4,  int n){
	//int maxrand =(1<<(coeff-n));
	int maxrand =n;
	int r = chooseRandom(maxrand);
//	printf ("Square max_rand = %d, p1x=%d p2x=%d p1y=%d p3y=%d\n",maxrand, p1.x, p2.x, p1.y, p3.y);
	//printf("tab[%d,%d][%d] = %d\n",(p1.x +p2.x )/2, (p1.y+p3.y)/2,((p1.x +p2.x )/2)*(largeur+1)+ (p1.y+p3.y)/2,((p1.z+p2.z+p3.z+p4.z)/4)+r);
	tableau [((p1.x +p2.x )/2)*(largeur+1)+ (p1.y+p3.y)/2].z = (p1.z+p2.z+p3.z+p4.z)/4 \
						+r;
	
}
void Array2::Triangle(Point p1, Point p2,Point p3,  int n){	
	//int maxrand =(1<<(coeff-n));
	int maxrand =n;
	int r = chooseRandom(maxrand);
	//printf ("Triangle p1x=%d p2x=%d p1y=%d p2y= %d p3y=%d\n",p1.x, p2.x, p1.y, p2.y, p3.y);
	if (p1.y==p2.y){
		//printf("tab[%d,%d][%d] = %d\n",(p1.x +p2.x )/2, p1.y,((p1.x +p2.x )/2)*(largeur+1)+ p1.y,((p1.z+p2.z+p3.z)/3)+r);
		if (tableau [((p1.x +p2.x )/2)*(largeur+1)+ p1.y].z == 0)
		{
			tableau [((p1.x +p2.x )/2)*(largeur+1)+ p1.y].z = (p1.z+p2.z+p3.z)/3 +r;
		} else {
			if ((p1.y==largeur) || (p1.y==0))
			{
				;
			} else {
				tableau [((p1.x +p2.x )/2)*(largeur+1)+ p1.y].z = (((p1.z+p2.z+p3.z)/3 +r)+(tableau [((p1.x +p2.x )/2)*(largeur+1)+ p1.y].z))/2;
			}
		}
	} else { //p1.x == p2.x
		//printf("tab[%d,%d][%d] = %d\n",p1.x, (p1.y+p2.y)/2,(p1.x)*(largeur+1)+ (p1.y+p2.y)/2,((p1.z+p2.z+p3.z)/3)+r);
		if (tableau [(p1.x)*(largeur+1)+ (p1.y+p2.y)/2].z ==0)
		{
			tableau [(p1.x)*(largeur+1)+ (p1.y+p2.y)/2].z = (p1.z+p2.z+p3.z)/3 +r;
		}else {
			if ((p1.x==largeur)|| (p1.x==0))
			{
				;
			} else {
				tableau [(p1.x)*(largeur+1)+ (p1.y+p2.y)/2].z = (((p1.z+p2.z+p3.z)/3 +r)+(tableau [(p1.x)*(largeur+1)+ (p1.y+p2.y)/2].z))/2;

			}
		}
	}

}
void Array2::detaille (int x, int y,int  n, int rd){
	if (n!=0){
		/*int v2expnm1=(1<<n)-1;
		int v2exp_nm1_m1=(1<<(n-1))-1; */
		int v2expnm1=(1<<n);
		int v2exp_nm1_m1=(1<<(n-1)); 
		//printf ("x=%d y=%d, n=%d, (2expN)-1 = %d, 2exp(N-1)-1=%d \n",x,y,n,v2expnm1,v2exp_nm1_m1);
		Square(
			tableau[x*(largeur+1)+y],
			tableau[(x+v2expnm1)*(largeur+1)+y],
			tableau[x*(largeur+1)+ y+v2expnm1],
			tableau[(x+v2expnm1)*(largeur+1)+ y+v2expnm1],
			rd
		);
		Triangle(
			tableau[x*(largeur+1)+y],
			tableau[(x+v2expnm1)*(largeur+1)+ y],
			tableau[(x+v2exp_nm1_m1)*(largeur+1)+ y+v2exp_nm1_m1],
			rd		
		);	
		Triangle(
			tableau[(x+v2expnm1)*(largeur+1)+ y],
			tableau[(x+v2expnm1)*(largeur+1)+ y+v2expnm1],
			tableau[(x+v2exp_nm1_m1)*(largeur+1)+ y+v2exp_nm1_m1],
			rd
		);	
		Triangle(
			tableau[x*(largeur+1)+ y+v2expnm1],
			tableau[(x+v2expnm1)*(largeur+1)+ y+v2expnm1],
			tableau[(x+v2exp_nm1_m1)*(largeur+1)+ y+v2exp_nm1_m1],
			rd
		);	
		Triangle(
			tableau[x*(largeur+1)+y],
			tableau[x*(largeur+1)+ y+v2expnm1],
			tableau[(x+v2exp_nm1_m1)*(largeur+1)+ y+v2exp_nm1_m1],
			rd
		);	
		detaille (x,y,n-1,rd/2);
		detaille (x+v2exp_nm1_m1, y,n-1,rd/2);
		detaille (x,y+v2exp_nm1_m1,n-1, rd/2);
		detaille (x+v2exp_nm1_m1, y+v2exp_nm1_m1,n-1, rd/2);
	}
}
void Array2::Build(){
	
	//for (int ii=0; ii<=largeur; ii++){
//		for (int jj=0; jj<=largeur; jj++) {
//			printf(" tab [%d,%d] = ()\n",ii,jj,tableau[ii*(largeur+1)+jj]);
//		}
//	}
	detaille (0, 0,coeff, MAX/2);

  /*      for (int ii=0; ii<=(1<<coeff); ii++){
                for (int jj=0; jj<=(1<<coeff); jj++) {
 			printf ("\t%d",getElement(ii,jj));
                 }
 		printf ("\n");
        }*/
	/*for (int jj=0; jj<12; jj++) {
		printf ("rand = %d\n", rand());
	}*/

}

